﻿Imports Microsoft.Office.Interop
Imports Microsoft.Office.Core
Public Class Form1

    Dim objPPT As PowerPoint.Application
    Dim objPres As PowerPoint.Presentation

    Private Sub cmdStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdIniciar.Click
        IniciarPowerPoint()
    End Sub
    Private Sub cmdCriarApresentacao_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdCriarApresentacao.Click
        AsseguraPowerPointEstaEmExecucao(False, False)
        'Adiciona Apresentacao
        objPres = objPPT.Presentations.Add(MsoTriState.msoTrue)
    End Sub
    Private Sub cmdAdicionarSlide_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAdicionarSlide.Click
        Dim objSlide As PowerPoint.Slide
        Dim objCustomLayout As PowerPoint.CustomLayout
        AsseguraPowerPointEstaEmExecucao(True)
        'Cria um layout customizado baseado no primeiro layoute master para simplificar
        objCustomLayout = objPres.SlideMaster.CustomLayouts.Item(1)
        'Cria slide
        objSlide = objPres.Slides.AddSlide(1, objCustomLayout)
        'Define o layout
        objSlide.Layout = PowerPoint.PpSlideLayout.ppLayoutText
        'Limpa
        objCustomLayout.Delete()
        objCustomLayout = Nothing
        objSlide = Nothing
    End Sub
    Private Sub cmdRemoverSlide_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRemoverSlide.Click
        AsseguraPowerPointEstaEmExecucao(True)
        If objPres.Slides.Count > 0 Then
            objPres.Slides(1).Delete()
        Else
            MsgBox("Nenhum slide para remover", MsgBoxStyle.Information)
        End If
    End Sub
    Private Sub cmdDefinirTitulo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDefinirTitulo.Click
        Dim i As Integer
        AsseguraPowerPointEstaEmExecucao(True, True)
        'Adiciona Text ao titulo do slide
        'Se não existe não faz nada
        objPres.Slides(1).Select()
        For i = 1 To objPres.Slides(1).Shapes.Count
            If objPres.Slides(1).Shapes(i).HasTextFrame Then
                objPres.Slides(1).Shapes(i).TextFrame.TextRange.Text = Me.txtTitle.Text
                Exit For
            End If
        Next i
    End Sub
    Private Sub cmdAdicionarGrafico_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAdicionarGrafico.Click
        Dim ds As New ShipmentSchema, dt As ShipmentSchema.ShipmentDataTable
        AsseguraPowerPointEstaEmExecucao(True, True)
        'carrega dados do arquivo xml 
        ds.ReadXml(My.Application.Info.DirectoryPath & "\ShipmentData.xml")
        dt = ds.Tables("Shipment")
        'Inicia o excel, popula a planilha com dados XML, cria o gráfico no Excel e copia para o Powerpoint
        Dim objExcel As Excel.Application
        Dim objWorkbook As Excel.Workbook
        Dim objSheet As Excel.Worksheet
        Dim objChart As Excel.Chart
        objExcel = New Excel.Application
        objExcel.Visible = True
        objWorkbook = objExcel.Workbooks.Add
        objSheet = objWorkbook.Sheets("Planilha1")
        DataTableParaPlanilhaExcel(dt, objSheet, 1, 1)
        objSheet.Range("A1:B4").Select()
        objChart = objExcel.Charts.Add()
        With objChart
            'gráfico de pizza 3D
            .ChartType = Excel.XlChartType.xl3DPie
            .ChartStyle = 10
            'permite redimensionar o grafico
            .AutoScaling = False
            .Elevation = 30
            .Select()
        End With
        Application.DoEvents()
        'objExcel.Selection.width = 300
        'objExcel.Selection.Height = 300
        'maio--2018-----------------------------------
        'Copia a imagem do grafico para o clipboard
        objChart.CopyPicture(Excel.XlPictureAppearance.xlPrinter, Excel.XlCopyPictureFormat.xlPicture, Excel.XlPictureAppearance.xlPrinter)
        'cola no PowerPoint
        objPPT.Activate()
        Dim objSlide As PowerPoint.Slide
        Dim objShape As PowerPoint.Shape
        objSlide = objPres.Slides(1)
        objSlide.Select()
        objSlide.Layout = PowerPoint.PpSlideLayout.ppLayoutTitleOnly
        objSlide.Shapes.Paste()
        objShape = objSlide.Shapes(2)
        objShape.ZOrder(MsoZOrderCmd.msoSendToBack)
        objShape.Left = 400
        objShape.Top = 100
        'Limpa
        objWorkbook.Close(False)
        objExcel.Quit()
        objExcel = Nothing
    End Sub
    Private Sub cmdAdicionarTabela_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAdicionarTabela.Click
        Dim objShape As PowerPoint.Shape
        Dim objTable As PowerPoint.Table
        AsseguraPowerPointEstaEmExecucao(True, True)
        'Carrega o  data table a partir do arquivo XML 
        Dim ds As New ShipmentSchema, dt As ShipmentSchema.ShipmentDataTable
        ds.ReadXml(My.Application.Info.DirectoryPath & "\ShipmentData.xml")
        dt = ds.Tables("Shipment")
        'Adiciona a tabela no primeiro slide
        objPres.Slides(1).Select()
        objShape = objPres.Slides(1).Shapes.AddTable(5, 2, 50, 100, 300)
        objTable = objShape.Table
        'Popula a tabela do dataset
        With objShape.Table
            .Cell(1, 1).Shape.TextFrame.TextRange.Text = dt.Columns.Item(0).ColumnName
            .Cell(1, 2).Shape.TextFrame.TextRange.Text = dt.Columns.Item(1).ColumnName
            'Aplica um estilo na tabela usando o estilo GUID
            .ApplyStyle("{B301B821-A1FF-4177-AEE7-76D212191A09}", False)
            Dim nRow As Integer, nCol As Integer
            For nRow = 0 To dt.Rows.Count - 1
                For nCol = 0 To dt.Columns.Count - 1
                    .Cell(2 + nRow, 1 + nCol).Shape.TextFrame.TextRange.Text = dt.Rows(nRow).Item(nCol)
                Next nCol
            Next nRow
        End With
        'Limpa
        objTable = Nothing
        objShape = Nothing
        dt = Nothing
        ds = Nothing
    End Sub
    Private Sub cmdAdicionarTextbox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdAdicionarTextbox.Click
        Dim objShape As PowerPoint.Shape
        Dim strText As String = "Campinas : embarques aumento de 10%" & vbCrLf & "Santos : embarque pronto"
        AsseguraPowerPointEstaEmExecucao(True, True)
        objPres.Slides(1).Select()
        objShape = objPres.Slides(1).Shapes.AddTextbox(MsoTextOrientation.msoTextOrientationHorizontal, 50, 300, 300, 300)
        objShape.TextFrame.AutoSize = PowerPoint.PpAutoSize.ppAutoSizeShapeToFitText
        objShape.TextFrame.TextRange.Text = strText
        objShape.TextEffect.FontSize = 20
        objShape.TextEffect.FontBold = MsoTriState.msoTrue
        'Limpa
        objShape = Nothing
    End Sub
    Sub IniciarPowerPoint()
        objPPT = New PowerPoint.Application
        objPPT.Visible = MsoTriState.msoTrue
        objPPT.WindowState = PowerPoint.PpWindowState.ppWindowMaximized
    End Sub
    Sub AsseguraPowerPointEstaEmExecucao(Optional ByVal blnAdicionaApresentacao As Boolean = False, Optional ByVal blnAdicionaSlide As Boolean = False)
        Dim strNome As String
        'Tenta acessar a propriedade nomer
        Try
            strNome = objPPT.Name
        Catch ex As Exception
            IniciarPowerPoint()
        End Try
        '
        If blnAdicionaApresentacao = True Then
            Try
                strNome = objPres.Name
            Catch ex As Exception
                objPres = objPPT.Presentations.Add(MsoTriState.msoTrue)
            End Try
        End If
        '
        If blnAdicionaSlide Then
            Try
                strNome = objPres.Slides(1).Name
            Catch ex As Exception
                Dim objSlide As PowerPoint.Slide
                Dim objCustomLayout As PowerPoint.CustomLayout
                objCustomLayout = objPres.SlideMaster.CustomLayouts.Item(1)
                objSlide = objPres.Slides.AddSlide(1, objCustomLayout)
                objSlide.Layout = PowerPoint.PpSlideLayout.ppLayoutText
                objCustomLayout = Nothing
                objSlide = Nothing
            End Try
        End If
    End Sub
    Private Sub cmdSair_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdSair.Click
        Try
            objPres.Close()
            objPres = Nothing
        Catch
        End Try
        Try
            objPPT.Quit()
            objPPT = Nothing
        Catch ex As Exception
        End Try
        System.GC.Collect()
    End Sub
    Sub DataTableParaPlanilhaExcel(ByVal dt As DataTable, ByVal objSheet As Excel.Worksheet, ByVal nStartRow As Integer, ByVal nStartCol As Integer)
        Dim nRow As Integer, nCol As Integer
        'copia o  datatable na planilha excel
        For nRow = 0 To dt.Rows.Count - 1
            For nCol = 0 To dt.Columns.Count - 1
                objSheet.Cells(nStartRow + nRow, nStartCol + nCol) = dt.Rows(nRow).Item(nCol)
            Next nCol
        Next nRow
    End Sub
End Class
